{ This file was taken from the freepascal mailing list during a benchmark
  war for the uppercase function }

program project1;
{$mode objfpc}
{$H+}

// Renamed cpu to cpu-timer, because the existence of a cpu-unit in the RTL
uses
  cpu_timer, sysutils;


function LowerCase1(const S: string): string;
var
 i: integer;
begin
  result := S;
  i := Length(result);
  while i <> 0 do
  begin
    if (result[i] in ['A'..'Z']) then result[i]:= char(byte(result[i]) + 32);
    dec(i);
  end;
end;

function Lowercase2(const S: string): string;
var
  i : Integer;

begin
  result := S;
  for i := Length(S) downto 1 do
    if (result[i] in ['A'..'Z']) then result[i]:= char(byte(result[i]) + 32);
end;

Function Lowercase3(const S: string): string;
var
  i : Integer;
begin
  result := S;
  for i := 1 to Length(S) do
    if (result[i] in ['A'..'Z']) then result[i]:= char(byte(result[i]) + 32);
end;

function Lowercase4(const S: string): string;
var
  i : Integer;
  P : PChar;
begin
  result := S;
  UniqueString(Result);
  P:=Pchar(Result);
  for i := 1 to Length(Result) do
  begin
    if (P^ in ['A'..'Z']) then P^:= char(byte(p^) + 32);
    Inc(P);
  end;
end;

var
  ConvertTable : array[0..255] of char;

function Lowercase5(const S: string): string;
var
  i : Integer;
  P : PChar;

begin
  result := S;
  UniqueString(Result);
  P:=Pchar(Result);
  for i := 1 to Length(Result) do
  begin
    if (P^ in ['A'..'Z']) then P^:= ConvertTable[byte(p^)];
    Inc(P);
  end;
end;

function Lowercase6(const S: string): string;
var
  i : Integer;
  P : PChar;
begin
  result := S;
  UniqueString(Result); // Needed or S will be modified.
  P:=Pchar(Result);
  for i := 1 to Length(Result) do
  begin
    P^ := ConvertTable[byte(p^)];
    Inc(P);
  end;
end;

{$ifdef FPC}{$ASMMODE INTEL}{$endif}
{$H-}

function lowercase7(const s:string):string;assembler;pascal;
asm
 {$ifndef FPC}
 push bx
 push esi
 push edi
 {$endif}
    mov esi,s
    mov edi,@result
    lodsb
    stosb
    movzx ecx,al
    jecxz @a2
@a1:
    lodsb
    cmp al,'A'
    sbb bl,bl
    cmp al,'Z'+1
    sbb bh,bh
    not bh
    or bl,bh
    not bl
    and bl,32
    add al,bl
    stosb
    dec cl
    jnz @a1
@a2:
 {$ifndef FPC}
 pop edi
 pop esi
 pop bx
 {$endif}
end;
{$H+}

type
 charaty = array[0..0] of char;
 pcharaty = ^charaty;

function Lowercase8(const S: String): String;
var
 int1: integer;
begin
  setlength(result,length(s));
  for int1:= length(s)-1 downto 0 do
  begin
    pcharaty(result)^[int1]:= converttable[byte(pcharaty(s)^[int1])];
  end;
end;

Function Lowercase9(Const S: String): String;
var
  int1: integer;
begin
  int1:= length(s);
  if int1 > 0 then begin
  setlength(result,int1);
  asm
   push ebx
   mov ebx,[pointer(s)]
   mov ecx,[ebx-4] //length
   jz @l1
   mov edx,[pointer(result)]
   {$ifndef FPC}
   mov edx,[edx]
   {$endif}
   dec ebx         //index is length downto 1
   dec edx
   xor eax,eax
  @l2:
   mov al,[ebx+ecx]
   mov al,[eax+converttable]
   mov [edx+ecx],al
   loop @l2
  @l1:
   pop ebx
  end;
  end
  else
  begin
   result:= '';
  end;
end;

var
  start, stop : int64;
  s,t         : string;
  i           : integer;

const
  count = 50000;

begin
  For I:=0 to 255 do
  {$ifdef FPC}
    ConvertTable[i]:=LowerCase(Char(i));
  {$else}
    ConvertTable[i]:=LowerCase(Char(i))[1];
  {$endif}

  s := 'QWERTYuiOP[]asdfghjkl;''\/.,MnBvcxz!@#$55tGGbvXCXg5eujFNBCx4w#^$&hfgbccxvfSFDCSjfDF145tySDFVmbCDl;k d;DCrbrdb6334fdb,\bx FG';

  start := Clock;
  for i := 0 to count do
    t := lowercase(s);
  stop := Clock;
  writeln('lowercase   execution time: ',stop-start);

  start := Clock;
  for i := 0 to count do
    t := lowercase1(s);
  stop := Clock;
  writeln('lowercase 1 execution time: ',stop-start);

  start := Clock;
  for i := 0 to count do
    t := lowercase2(s);
  stop := Clock;
  writeln('lowercase 2 execution time: ',stop-start);

  start := Clock;
  for i := 0 to count do
    t := lowercase3(s);
  stop := Clock;
  writeln('lowercase 3 execution time: ',stop-start);

  start := Clock;
  for i := 0 to count do
    t := lowercase4(s);
  stop := Clock;
  writeln('lowercase 4 execution time: ',stop-start);

  start := Clock;
  for i := 0 to count do
    t := lowercase5(s);
  stop := Clock;
  writeln('lowercase 5 execution time: ',stop-start);

  start := Clock;
  for i := 0 to count do
    t := lowercase6(s);
  stop := Clock;
  writeln('lowercase 6 execution time: ',stop-start);
  start := Clock;
  for i := 0 to count do
    t := lowercase7(s);
  stop := Clock;
  writeln('lowercase 7 execution time: ',stop-start);
  start := Clock;
  for i := 0 to count do
    t := lowercase8(s);
  stop := Clock;
  writeln('lowercase 8 execution time: ',stop-start);

  start := Clock;
  for i := 0 to count do
    t := lowercase9(s);
  stop := Clock;
  writeln('lowercase 9 execution time: ',stop-start);

  writeln;
  writeln('Done.');
  writeln('Press <enter> to exit');
  readln;
end.


